locals @@

code segment dword public 'CODE'
assume cs:code,ds:code

.386

  EXTRN  xorbuffer:dword,num_values:word,mvbl:word
  PUBLIC setslide,maketable,endecrypt

; EQUs for easy editing :-)
  SLIDE  equ word  ptr ss:[bp]    ; setslide
  SEED   equ dword ptr ss:[bp]    ; maketable
  XORVAL equ dword ptr ss:[bp]    ; \
  COUNT  equ word  ptr ss:[bp+4]  ;  > endecrypt
  BUFFER equ dword ptr ss:[bp+6]  ; /

; I only put the copypright in here to be able to see where
; in the .exe file my engine goes. Remove it if you want to.
  copyright db 'CRYPT engine v0.9 - by Sune Marcher'

  slide_ofs  dw 1                 ; offset in the XORbuffer. Start with 1.

setslide proc far                 ; setslide(slide:word)
  push bp                         ; save BP for pascal
  mov  bp,sp                      ; BP=SP since we can't address with SP
  add  bp,6                       ; skip BP+4byte return to get to params

  mov  ax,SLIDE
  mov  slide_ofs,ax

  pop  bp                         ; restore BP for pascal
  retf 2                          ; return, discard one param
setslide endp

maketable proc far                ; maketable(seed:longint)
  push bp                         ; \
  mov  bp,sp                      ;  > save stuff, skip to params
  add  bp,6                       ; /
; build the XOR table
  xor  ecx,ecx

  lgs  di,xorbuffer
  mov  cx,num_values
  mov  eax,SEED
  mov  ebx,eax
  mov  edx,eax
  shr  edx,cl
  and  ebx,edx
;  xor  bx,bx
@@loopi:
  rol  eax,1
  not  eax
  add  eax,ebx
  sub  eax,ecx
  mov  dword ptr gs:[di],eax

  inc  ebx
  add  di,4
  dec  ecx
  jnz  @@loopi

  pop  bp                         ; \ restore & return
  retf 4                          ; /
maketable endp

endecrypt proc far                ; endecrypt(buffer,bufsize,xorval)
  push  bp                        ; \
  mov   bp,sp                     ;  > the same old crap :-)
  add   bp,6                      ; /

  mov  cx,COUNT
  jcxz @@done

  lgs  si,xorbuffer
  lfs  di,BUFFER
  mov  bx,slide_ofs               ; bx will be temporary slide offset.
  add  si,bx

.286
  shr  cx,1                       ; \ split to WORD instructions
  jnc  @word1                     ; /
.386
  mov  al,byte ptr fs:[di]
  xor  al,byte ptr gs:[si]
  xor  al,byte ptr XORVAL
  inc  si
  inc  bx
  inc  di
  jcxz @@done
@word1:
.286
  shr  cx,1                       ; \ split to DWORD based instructions
  jnc  @@loopi                    ; /
.386
  mov  ax,word ptr fs:[di]
  xor  ax,word ptr gs:[si]
  xor  ax,word ptr XORVAL
  add  si,2
  add  bx,2
  add  di,2
  jcxz @@done
  align 4 ; align the main loop, to make stuff go a (tiny) bit faster
@@loopi:
  mov eax,dword ptr fs:[di]              ; get dword to encrypt
  xor eax,dword ptr gs:[si]              ; encrypt EAX with table
  xor eax,XORVAL                         ; encrypt EAX with xorval
  mov dword ptr fs:[di],eax              ; store the encrypt dword back.

  add  si,4
  add  bx,4
  cmp  bx,mvbl
.286
  jb   @@no_flow
.386
  sub  si,bx
  xor  bx,bx
@@no_flow:
  add  di,4                              ; point to the next dword.
  dec  cx
  jnz  @@loopi
@@done:
  pop  bp
  retf 10
endecrypt endp

code ends
     end